#ifndef _COMMON_ALL_H_
#define _COMMON_ALL_H_

//commonディレクトリ内全てをインクルードする
//簡単に使うためのラッパークラスも用意する

//基本的定義
#include "defines.h"

//乱数

#include"lib/dSFMT-src-2.2.3/dSFMT.h"
#include"lib/dSFMT-src-2.2.3/dSFMT.c"

struct DSFMT{
	dsfmt_t dsfmt;
	uint32 rand(){//整数
		return dsfmt_genrand_uint32(&dsfmt);
	}
	double drand(){
		return dsfmt_genrand_open_open(&dsfmt);
	}
	void srand(uint32 s){
		dsfmt_init_gen_rand(&dsfmt,s);
	}
};

#include"util/xorShift.hpp"
#include"util/rkiss.hpp"
#include"util/random.hpp"

//ビット演算
#include"util/bitOperation.hpp"

//包括ユーティリティ
#include"util/container.hpp"
#include"util/arrays.h"

//クラスユーティリティ
#include"util/bitSet.hpp"
#include"util/bitArray.hpp"
#include"util/stack.hpp"
#include"util/biStack.hpp"

//応用ユーティリティ
#include"util/bitPartition.hpp"

//解析用
#include"util/math.hpp"

//ハッシュ
#include"hash/HashFunc.hpp"
#include"hash/HashBook.hpp"

//多腕バンディット問題
#include"util/multiArmedBandit.hpp"

//並列化
#include"util/lock.hpp"

#endif  /* _COMMON_ALL_H_ */