﻿/*
 common utility
 lock.hpp
 */


#ifndef _LOCK_HPP_
#define _LOCK_HPP_

#include"../defines.h"

//排他処理用スピンロック
//モンテカルロのコンピュータ囲碁の本を参考に

void lock(volatile int *ptr){
#ifdef WIN64_LOCK_INTERLOCK
	for(;;){
		if( _interlockedbittestandset( (long*)(ptr), 0 ) ){
			return;
		}
		while(*ptr);
	}
#else 
#if defined(_MSC_VER)
	__asm
	{
		mov  ecx, &l
	la: mov  eax, 1
		xchg eax, [ecx]
		test eax, eax
		jz   end
	ln:
		pause
		mov  exax, [ecx]
		test eax, eax
		jz   la
		jmp  lb
	end:
	}
#else
	int itmp;
	for(;;){
		asm( "1: movl  $1,  %1 \n\t"
			"   xchgl (%0),%1 \n\t"
			:"=g" (ptr), "=r" (itmp) : "0" (ptr) );
		if( !itmp ){return;}
		while(*ptr);
	}
#endif
#endif
	assert(0);
}
void unlock(volatile int *ptr){
	*ptr=0;
}


#endif //_LOCK_HPP_