﻿/*
 multiArmedBandit.hpp 
 */


#ifndef _MULTIARMEDBANDIT_HPP_
#define _MULTIARMEDBANDIT_HPP_

#include"../defines.h"

//多腕バンディット問題を扱う時の基本的な演算

double calc_ucb1(uint32 eval_sum,uint32 size,uint32 all_size,double K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/(double)size + K * std::sqrt(std::log((double)all_size)/size);
}

double calc_ucb1(double eval_sum,uint32 size,uint32 all_size,double K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/(double)size + K * std::sqrt(std::log((double)all_size)/size);
}

double calc_ucb1(double eval_sum,double size,double all_size,double K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/size + K * std::sqrt(std::log(all_size)/size);
}
/*
float calc_ucb1(uint32 eval_sum,uint32 size,uint32 all_size,float K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/(float)size + K * std::sqrt(std::log((float)all_size)/size);
}

float calc_ucb1(float eval_sum,uint32 size,uint32 all_size,float K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/(float)size + K * std::sqrt(std::log((float)all_size)/size);
}

float calc_ucb1(float eval_sum,float size,float all_size,float K){
	//UCB1
	ASSERT( size>0 && all_size>0, std::cerr<<size<<" "<<all_size<<endl; );
	return eval_sum/size + K * std::sqrt(std::log(all_size)/size);
}
*/
#endif //_MULTIARMEDBANDIT_HPP_ 