﻿#ifndef _SOCKETLISTENER_HPP_
#define _SOCKETLISTENER_HPP_

#include<iostream>
#include "../defines.h"


//ソケット通信サイズが可変だったりして上手く行かない時用
template<int SOCKETLISTENER_BUF_LEN=256>
class SocketListener{
private:
	char buf[SOCKETLISTENER_BUF_LEN];
	int cur_idx;
public:
	
	void init(){
		cur_idx=-1;
		memset(buf,0,sizeof(buf));
	}
	
	template<class socket_t>
	int recv(const socket_t& sock,char *c,const int size,const uint32 flag){
		int tmp_size=0;
		
		if( cur_idx==-1 ){
			recv( sock, buf, sizeof(buf), flag );
			cur_idx=0;
		}
		while(tmp_size<size-1){
			for(int i=cur_idx;i<SOCKETLISTENER_BUF_LEN;++i){
				//1文字ずつcに移していく
				char tc=buf[i];
				if( tc=='\0' ){
					if( tmp_size==0 ){
						//サイズが0のとき、ヌル文字は飛ばす
						continue;
					}else{
						//終了
						if( i==SOCKETLISTENER_BUF_LEN ){
							memset(buf,0,sizeof(buf));
							cur_idx=-1;
						}else{
							++cur_idx;
						}
						break;
					}
					c[tmp_size]=tc;
				}
			}
		}
		//最後にヌル文字を加える
		c[tmp_size]='\0';
		return tmp_size+1;
	}
};


	
#endif /* _SOCKETLISTENER_HPP_ */