﻿/*
 Wisteria Daifugo Library
 xorShift.hpp 
 */


#ifndef _XORSHIFT_HPP_
#define _XORSHIFT_HPP_

#include"../defines.h"

//xorshiftによる乱数生成

//クラス
class XorShift64{
private:
	uint64 x,y,z,t;
public:
	uint64 rand(){
		uint64 tmp=x^(x<<11);
		x=y;
		y=z;
		z=t;
		t=(t^(t>>19))^(tmp^(tmp>>8));
		return t;
	}
	void srand(const uint64 s){
		if(!s){//seedが0だとまずい
			x=0x0123456789ABCDEF;
		}else{
			x=(s<<32)^s;
		}
		y=(z<<8)|((x&0xff00000000000000)>>56);
		z=(y<<8)|((y&0xff00000000000000)>>56);
		t=(z<<8)|((z&0xff00000000000000)>>56);
	}
	uint64 min()const{return 0ULL;}
	uint64 max()const{return 0xFFFFFFFFFFFFFFFF;}
	
	constexpr XorShift64()
	:x(),y(),z(),t(){}
	
	XorShift64(const uint64 s){srand(s);}
};


#endif /* _XORSHIFT_HPP_ */