﻿//blue skip基本設定
//設定パターンによっては動かなくなるかもしれないので注意

//プロフィール
const std::string MY_NAME="Ayumu";
const std::string MY_VERSION="150307";
const std::string MY_COACH="KatsukiOhto";

//接続用プロフィール
#define MY_ID "ayumu"
#define MY_PASSWORD "ayumu_open"

#ifdef FOR_NETWORK
#define SERVER_IP "130.153.151.129"
#else
#define SERVER_IP "127.0.0.1"
#endif

//重要な設定

//#define FOR_TOURNAMENT //本番用
#define MONITOR //着手決定関連の表示
#define BROADCAST //試合進行実況
//#define DEBUG //デバッグ出力

//並列化
//スレッド数(ビルド時決定)
//0以下を設定すると勝手に1になります
//9以上だとstatic assertが反応してコンパイルに失敗します
#define N_THREADS (8)

//メソッドアナライザー使用
//本番用では自動的にオフ
#define USE_ANALYZER

//浮動小数点演算の型。高速な方を使う
//メモリ節約のためのfloat使用は内部で固定されているので関係無し
//typedef float fpn_t;
typedef double fpn_t;

//精度を上げたいときの浮動小数点型
//typedef __float128 pfpn_t;
typedef long double pfpn_t;

/**************************以下は直接変更しない**************************/

//スレッド数
#ifdef N_THREADS

#if N_THREADS <= 0
#undef N_THREADS
#define N_THREADS (1)
#endif

//スレッド数として2以上が指定された場合は、マルチスレッドフラグを立てる
#if N_THREADS>=(2)
#define MULTI_THREADING
#endif

#endif /* N_THREADS */


//本番用のとき、プレーに無関係なものは全て削除
//ただしバグ落ちにdefineが絡む可能性があるので、強制終了時の出力は消さない
#ifdef FOR_TOURNAMENT

//デバッグ
#ifdef DEBUG
#undef DEBUG
#endif

//実況
#ifdef BROADCAST
#undef BROADCAST
#endif

//アナライザ
#ifdef USE_ANALYZER
#undef USE_ANALYZER
#endif

#endif /* FOR_TOURNAMENT */

