//デジタルカーリング用
//ストーンの速度ベクトルにかかる乱数について検討

namespace DigitalCurling{
	
	struct fRandXY{fpn_t x,y;};
	
	//fRandXY randToMoveXYTable[1<<14];
	
	template<class dice_t>
	void genRandToMoveXY(fpn_t *const dvx,fpn_t *const dvy,dice_t *const pdice){

		Norm<fpn_t> norm(0,F_RAND_SIGMA);//正規分布
		
		//公式提供のヒューリスティック関数で導いたティーショットの速度ベクトル
		constexpr fpn_t FVX_TEESHOT_LEGAL=-0.99073974;
		constexpr fpn_t FVY_TEESHOT_LEGAL=+29.559775;
		
		fPosXY<> pos;
		fMoveXY<> shot;
		/*
		fPosXY<> TeePos;
		fMoveXY<> TeeShot;
		TeePos.x = FX_TEE;
		TeePos.y = FY_TEE;
		TeeShot.setSpin(0);
		FastSimulator::calcDeparture(TeePos, &TeeShot);
		*/
		fpn_t a,b;
		norm.rand(&a,&b,pdice);
		
		//DERR<<a<<","<<b<<endl;
		
		pos.x = FX_TEE + a;
		pos.y = FY_TEE + b;
		
		shot.setSpin(0);
		
		Simulator::calcDeparture(pos, &shot);
		
		*dvx=FVX_TEESHOT_LEGAL - shot.x;
		*dvy=FVY_TEESHOT_LEGAL - shot.y;
	}
	
	template<class move_t,class dice_t>
	void addRandToMove(move_t *const mv,dice_t *const pdice){
		//着手直交速度ベクトルに正規乱数をかける
		
		//static StaticClock c;
		
		//c.start();	
		
		fpn_t dvx,dvy;
		genRandToMoveXY(&dvx,&dvy,pdice);
		mv->addVX( dvx );
		mv->addVY( dvy );
		
		//uint32 r=((uint32)pdice->rand())%(1<<14);
		//mv->addVX( randToMoveXYTable[r].x );
		//mv->addVY( randToMoveXYTable[r].y );
		
		//c.stop();
	}
	

	
	void testRand(){
		//乱数の分布テスト
		int dist[32][32]={0};
		
		
		
	}
	
	template<class dice_t>
	void initRandToMove(dice_t *const pdice){
		//for(int i=0;i<(1<<14);++i){
		//	genRandToMoveXY(&randToMoveXYTable[i].x,&randToMoveXYTable[i].y,pdice);
		//}
	}
}

